<!-- Copyright 2005-07, Woody/mC and mediaCulture     All rights reserved. -->
<?PHP
/*********************************************** filezilla-ftp-pass.php ************************************************
************************************************************************************************************************
*** AUTHOR:    Woody/mC, woody@media-Culture.de                                                                      ***
*** DATE:      Sat, 09-Jun-2007                                                                                      ***
*** VERSION:   1.1.0                                                                                                 ***
************************************************************************************************************************
*** PURPOSE:   Defines high-level methods to manipulate the FileZilla Server configuration.                          ***
***                                                                                                                  ***
*** HISTORY:   V1.1.0   Woody/mC   FTP_AddUser() added, made some minor cosmetic changes.                            ***
***                                                                                                                  ***
***            V1.0.0   Woody/mC   Initial version, coded for personal use. Made public due to request from Oepfel,  ***
***                                a member of the ApacheFriends board at http://www.apachefriends.org/f/ .          ***
***                                                                                                                  ***
*** LICENSE:   Copyright 2005-07, Woody/mC and mediaCulture                                                        ***
***            All rights reserved.                                                                                  ***
***                                                                                                                  ***
***            The contents of this file, as well as all files that come bundled with it (furthermore called "THE    ***
***            SOFTWARE" are open-source freeware and may be used and/or modified according to the terms of the      ***
***            following LICENSE; this also includes any partial work, either in written or computationally          ***
***            processible form.                                                                                     ***
***            Use or modification imply that you accepted all the following conditions (slightly modified, but      ***
***            adapted from the Berkeley BSD license, which can be found at                                          ***
***            "http://www.opensource.org/licenses/bsd-license.php" ):                                               ***
***                                                                                                                  ***
***            Redistribution and use in source and binary forms, with or without modification, are permitted        ***
***            provided that the following conditions are met:                                                       ***
***                                                                                                                  ***
***            (0) Redistributions of source code must retain the above copyright notice, the topmost HTML copyright ***
***                comment, this list of conditions and the following disclaimer.                                    ***
***            (1) Redistributions in binary form must reproduce the above copyright notice, this list of conditions ***
***                and the following disclaimer in the documentation and/or other materials provided with the        ***
***                distribution.                                                                                     ***
***            (2) Neither the name and/or logo of mediaCulture and/or mC, the name and/or logo of the program, nor  ***
***                the names of its contributors may be used to endorse or promote products derived from this        ***
***                software without specific prior written permission.                                               ***
***                                                                                                                  ***
***            THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR        ***
***            IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND      ***
***            FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR             ***
***            CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL     ***
***            DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,     ***
***            DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN ***
***            CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE ***
***            USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.                              ***
***                                                                                                                  ***
***            mediaCulture, mC and the mC logo are registered trademarks of the author known by the pseudonym       ***
***            "Woody/mC" and the "mediaCulture" company.                                                            ***
***                                                                                                                  ***
************************************************************************************************************************
***********************************************************************************************************************/



// start your engines... :-)



// full path to "filezilla server.exe/.xml" (without extension), don't forget to quote correctly
define("FILEZILLA_SERVER_NAME","\\Program Files\\FileZilla Server\\FileZilla Server");

// specifies a file path for logging the password changes / change attempts
define("LOGFILE","./filezilla-ftp-pass.log");

// only members of these (filezilla) groups may change password.
// the "false" array entry stands for users which have no group assigned.
$CHPASS_AllowedGroups = Array(false,"group1","group2","group3");


// adds a filezilla user with standard settings.
// returns true if the user has been added, false otherwise
function FTP_AddUser($username,$usergroup,$password) {
  $XML = Array();
  $found = false;
  $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","r");
  if (@$fp) {
    $XML = split("\n", fread($fp, filesize(FILEZILLA_SERVER_NAME.".xml")));
    fclose($fp);
    }
  for($i=0; $i < count($XML); $i++) {
    $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<USER NAME=\"".strtoupper($username)."\">")===false));
    if ($found) break;
    }
  if ($found || (!$username)) {
  	$found = false; // do nothing if the user already exists or no user was given
  	} else {
    for($i=0; $i < count($XML); $i++) {
      $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "</USERS>")===false));
      if ($found) {
      	$NewUserEntry = Array(
         "<User Name=\"".$username."\">",
         "<Option Name=\"Pass\"".($password?">".strtolower(md5($password))."</Option":"/").">",
         "<Option Name=\"Group\"".($usergroup?">".$usergroup."</Option":"/").">",
         "<Option Name=\"Bypass server userlimit\">2</Option>",
         "<Option Name=\"User Limit\">0</Option>",
         "<Option Name=\"IP Limit\">0</Option>",
         "<Option Name=\"Enabled\">1</Option>",
         "<Option Name=\"Comments\"/>",
         "<Option Name=\"ForceSsl\">2</Option>",
         "<IpFilter>",
         "<Disallowed/>",
         "<Allowed/>",
         "</IpFilter>",
         "<Permissions/>",
         "<SpeedLimits DlType=\"0\" DlLimit=\"10\" ServerDlLimitBypass=\"2\" UlType=\"0\" UlLimit=\"10\" ServerUlLimitBypass=\"2\">",
         "<Download/>",
         "<Upload/>",
         "</SpeedLimits>",
         "</User>" );
        $XML = array_merge(array_slice($XML,0,$i),$NewUserEntry,array_slice($XML,$i));
        break;
        }
      }
    $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","w");
    if (@$fp) {
      $found = ((bool)(fwrite($fp, join("\n", $XML))>0) && $found);
      fclose($fp);
      } else {
      $found = false;
      }
    $_tmp = "\"".FILEZILLA_SERVER_NAME.".exe\" /reload-config";
    $_tmp = `$_tmp`; // shell execute
    }
  return $found;
	}

// returns true if filezilla user exists, false otherwise
function FTP_UserExists($username) {
  $XML = Array();
  $found = false;
  $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","r");
  if (@$fp) {
    $XML = split("\n", fread($fp, filesize(FILEZILLA_SERVER_NAME.".xml")));
    fclose($fp);
    }
  for($i=0; $i < count($XML); $i++) {
    $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<USER NAME=\"".strtoupper($username)."\">")===false));
    if ($found) break;
    }
  return $found;
  }

// returns true if user has access to the server, false otherwise
function FTP_UserEnabled($username) {
  $XML = Array();
  $found = false;
  $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","r");
  if (@$fp) {
    $XML = split("\n", fread($fp, filesize(FILEZILLA_SERVER_NAME.".xml")));
    fclose($fp);
    }
  for($i=0; $i < count($XML); $i++) {
    $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<USER NAME=\"".strtoupper($username)."\">")===false));
    if ($found) {
      $found = false;
      while ((strpos(strtoupper($XML[$i++]), "</USER>")===false) && !$found)
        $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<OPTION NAME=\"ENABLED\">1</OPTION>")===false));
      }
    if ($found) break;
    }
  return $found;
  }

// returns the name of the filezilla group the user has been assigned to,
// or false if he has not been assigned to any group
function FTP_UserGroup($username) {
  $XML = Array();
  $found = false;
  $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","r");
  if (@$fp) {
    $XML = split("\n", fread($fp, filesize(FILEZILLA_SERVER_NAME.".xml")));
    fclose($fp);
    }
  for($i=0; $i < count($XML); $i++) {
    $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<USER NAME=\"".strtoupper($username)."\">")===false));
    if ($found) {
      $found = false;
      while ((strpos(strtoupper($XML[$i++]), "</USER>")===false) && !$found) {
        $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<OPTION NAME=\"GROUP\">")===false));
        if ($found)
          $found = substr($XML[$i], strpos(strtoupper($XML[$i]), "<OPTION NAME=\"GROUP\">")+21, strpos(strtoupper($XML[$i]), "</OPTION>")-strpos(strtoupper($XML[$i]), "<OPTION NAME=\"GROUP\">")-21);
        }
      }
    if ($found) break;
    }
  return $found;
  }

// returns true if the given clear-text password matches the user's filezilla password, false otherwise
function FTP_PasswordCorrect($username,$password) {
  $XML = Array();
  $found = false;
  $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","r");
  if (@$fp) {
    $XML = split("\n", fread($fp, filesize(FILEZILLA_SERVER_NAME.".xml")));
    fclose($fp);
    }
  for($i=0; $i < count($XML); $i++) {
    $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<USER NAME=\"".strtoupper($username)."\">")===false));
    if ($found) {
      $found = false;
      while ((strpos(strtoupper($XML[$i++]), "</USER>")===false) && !$found)
        $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<OPTION NAME=\"PASS\">".strtoupper(md5($password))."</OPTION>")===false));
      }
    if ($found) break;
    }
  return $found;
  }

// all passwords you provide this function with need to be clear-text.
// returns true if the password has been replaced successfully, false otherwise.
// THIS DOES NOT IMPLY A SUCCESSFUL SERVER CONFIG RELOAD!
function FTP_SetNewPassword($username,$oldpass,$newpass) {
  $XML = Array();
  $found = false;
  $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","r");
  if (@$fp) {
    $XML = split("\n", fread($fp, filesize(FILEZILLA_SERVER_NAME.".xml")));
    fclose($fp);
    }
  for($i=0; $i < count($XML); $i++) {
    $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<USER NAME=\"".strtoupper($username)."\">")===false));
    if ($found) {
      $found = false;
      while ((strpos(strtoupper($XML[$i++]), "</USER>")===false) && !$found) {
        $found = ($found || (bool)!(strpos(strtoupper($XML[$i]), "<OPTION NAME=\"PASS\">".strtoupper(md5($oldpass))."</OPTION>")===false));
        if ($found)
          $XML[$i] = str_replace(strtolower(md5($oldpass)), strtolower(md5($newpass)), $XML[$i]);
        }
      }
    if ($found) break;
    }
  $fp=@fopen(FILEZILLA_SERVER_NAME.".xml","w");
  if (@$fp) {
    $found = ((bool)(fwrite($fp, join("\n", $XML))>0) && $found);
    fclose($fp);
    } else {
    $found = false;
    }
  $_tmp = "\"".FILEZILLA_SERVER_NAME.".exe\" /reload-config";
  $_tmp = `$_tmp`; // shell execute
  return $found;
  }

// self-explanatory :-)
function WriteLogEntry($User,$Action,$Message) {
  $fp=@fopen(LOGFILE,"a");
  if (@$fp) {
    fputs($fp,date("d-M-Y H:i:s")."\t".(@$_SERVER["REMOTE_HOST"]?strtolower(@$_SERVER["REMOTE_HOST"]):@$_SERVER["REMOTE_ADDR"])."\t".$User."\t".$Action."\t".$Message."\r\n");
    fclose($fp);
    }
  }

echo "
<HTML>
 <HEAD>
  <TITLE>Change FileZilla password</TITLE>
 </HEAD>
 <BODY ONLOAD=\"document.ftppassfrm.username.focus();\">
 ";

// process form contents, if submitted
if (strtoupper(@$_POST["action"])=="CHPASS") {
  if (!FTP_UserExists(@$_POST["username"])) {
    echo "<CENTER STYLE=\"color:red; border:1px solid red; background-color:#FFD0D0; padding:5px;\"><B>Setzen des Kennworts fehlgeschlagen: &nbsp; </B>Der Benutzer <B>".@$_POST["username"]."</B> wurde nicht gefunden.</CENTER><BR>";
    WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"FAILED: No such user");
    } else {
    if (!in_array(strtolower(FTP_UserGroup(@$_POST["username"])),@$CHPASS_AllowedGroups)) {
      echo "<CENTER STYLE=\"color:red; border:1px solid red; background-color:#FFD0D0; padding:5px;\"><B>Setzen des Kennworts fehlgeschlagen: &nbsp; </B>Der Benutzer <B>".@$_POST["username"]."</B> geh&ouml;rt einer Gruppe an, deren Kennw&ouml;rter nicht &uuml;ber diese Seite ge&auml;ndert werden d&uuml;rfen.</CENTER><BR>";
      WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"FAILED: Group \"".strtolower(FTP_UserGroup(@$_POST["username"]))."\" not allowed");
      } else {
      if (!FTP_UserEnabled(@$_POST["username"])) {
        echo "<CENTER STYLE=\"color:red; border:1px solid red; background-color:#FFD0D0; padding:5px;\"><B>Setzen des Kennworts fehlgeschlagen: &nbsp; </B>Der Benutzer <B>".@$_POST["username"]."</B> ist zur Zeit nicht aktiviert.</CENTER><BR>";
        WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"FAILED: User is disabled");
        } else {
        if (!FTP_PasswordCorrect(@$_POST["username"],@$_POST["oldpass"])) {
          echo "<CENTER STYLE=\"color:red; border:1px solid red; background-color:#FFD0D0; padding:5px;\"><B>Setzen des Kennworts fehlgeschlagen: &nbsp; </B>Das alte Kennwort wurde nicht korrekt eingegeben.</CENTER><BR>";
          WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"FAILED: Password mismatch");
          } else {
          if (strlen(@$_POST["newpass"])<6) {
            echo "<CENTER STYLE=\"color:red; border:1px solid red; background-color:#FFD0D0; padding:5px;\"><B>Setzen des Kennworts fehlgeschlagen: &nbsp; </B>Die Mindestl&auml;nge des neuen Kennworts betr&auml;gt 6 Zeichen.</CENTER><BR>";
            WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"FAILED: New password is too short");
            } else {
            if (@$_POST["newpass"]!=@$_POST["newpass2"]) {
              echo "<CENTER STYLE=\"color:red; border:1px solid red; background-color:#FFD0D0; padding:5px;\"><B>Setzen des Kennworts fehlgeschlagen: &nbsp; </B>Das neue Kennwort und die Kennwort-Wiederholung sind nicht identisch.</CENTER><BR>";
              WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"FAILED: New password does not match password verification");
              } else {
              if (!FTP_SetNewPassword(@$_POST["username"],@$_POST["oldpass"],@$_POST["newpass"])) {
                echo "<CENTER STYLE=\"color:red; border:1px solid red; background-color:#FFD0D0; padding:5px;\"><B>Setzen des Kennworts fehlgeschlagen: &nbsp; </B>Beim Schreiben der Server-Konfiguration ist ein Fehler aufgetreten.</CENTER><BR>";
                WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"FAILED: Unable to write server configuration file");
                } else {
                echo "<CENTER STYLE=\"color:green; border:1px solid green; background-color:#D0FFD0; padding:5px;\">Das Kennwort f&uuml;r den Benutzer <B>".@$_POST["username"]."</B> wurde erfolgreich ge&auml;ndert.</CENTER><BR>";
                WriteLogEntry(@$_POST["username"],strtoupper(@$_POST["action"]),"SUCCESS: Password changed");
                }
              }
            }
          }
        }
      }
    }
  } ?>

<!-- draw the html form -->
<FORM NAME="ftppassfrm" ACTION="<?=$_SERVER["PHP_SELF"];?>" METHOD="post">
 <INPUT NAME="action" TYPE="hidden" VALUE="chpass">
 <B>Benutzername:</B><BR>
 <INPUT NAME="username" TYPE="text" VALUE="<?=(strtoupper(@$_POST["action"])=="CHPASS"?@$_POST["username"]:@$_GET["usr"]);?>" STYLE="width:200"><BR>
 <B>Altes Kennwort:</B><BR>
 <INPUT NAME="oldpass" TYPE="password" VALUE="" STYLE="width:200"><BR>
 <B>Neues Kennwort:</B><BR>
 <INPUT NAME="newpass" TYPE="password" VALUE="" STYLE="width:200"><BR>
 <B>Neues Kennwort best&auml;tigen:</B><BR>
 <INPUT NAME="newpass2" TYPE="password" VALUE="" STYLE="width:200"><BR>
 <BR><INPUT NAME="ok" TYPE="submit" VALUE="Kennwort &auml;ndern" DEFAULT STYLE="width:150px; height:23px; font-size:11px; font-weight:bold;">
</FORM>
